#ifndef PROCESS_H_
#define PROCESS_H_


void Calibration();
void CONTROLLER_DATA_PROCESS();
void init_Drone_Setting();
void update_constants();
void HEADFREE_PROCESS();
void POSITION_CONTROL();

void Read_2Byte_Data(uint8_t *A,uint8_t *B,uint8_t size);

void    USB_SerialOpen(uint32_t baud);
void    BT_SerialOpen(uint32_t baud);
uint8_t USB_SerialRead();
//uint8_t BT_SerialRead();
void    USB_SerialWrite(uint8_t c);
//void    BT_SerialWrite(uint8_t c);
void    BT_SerialWrite16(uint16_t c);
uint8_t SerialAvailable(uint8_t port);
void    BT_SerialEnd();

void UartSendData(uint8_t port);


#define RX_BUFFER_SIZE 128 // 256 RX buffer is needed for GPS communication (64 or 128 was too short)
#define TX_BUFFER_SIZE 128

#define UART_NUMBER 2

extern uint8_t serialBufferRX[RX_BUFFER_SIZE][UART_NUMBER];



/* NEW: not used anymore for servo coptertypes  <== NEEDS FIXING - MOVE TO WIKI */
#define YAW_DIRECTION 1
//#define YAW_DIRECTION -1 // if you want to reverse the yaw correction direction
 

#define DRONE_MOTOR_PIDMIX(X,Y,Z) rcCommand[THROTTLE] + axisPID[ROLL]*X + axisPID[PITCH]*Y + YAW_DIRECTION * axisPID[YAW]*Z
//#define DRONE_MOTOR_PIDMIX(X,Y,Z) rcCommand[THROTTLE] - 1000 + axisPID[ROLL]*X + axisPID[PITCH]*Y + YAW_DIRECTION * axisPID[YAW]*Z



#endif /* PROCESS_H_ */
